- Main Page
- Modules
- Namespaces
- Classes
- Files
- Related Pages

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# FCDParameterListAnimatableT< TYPE, QUALIFIERS > Class Template Reference
[The generic FCollada parameter interface.]

A typed animatable FCollada value parameter. More...

`#include <FCDParameterAnimatable.h>`

Inheritance diagram for FCDParameterListAnimatableT< TYPE, QUALIFIERS >:

List of all members.

## Public Member Functions
| FCDParameterListAnimatableT (FUParameterizable *parent)
| Constructor.
virtual | ~FCDParameterListAnimatableT ()
| Destructor.
size_t | size () const
| Retrieves the number of values in this parameter list. See above.
bool | empty () const
| Retrieves whether this list parameter contains values.
void | resize (size_t count)
| Sets the number of values contained in the list parameter.
void | resize (size_t count, const TYPE &value)
| Sets the number of values contained in the list parameter.
const TYPE & | at (size_t index) const
| Retrieves one value held by this parameter.
const TYPE & | operator[] (size_t index) const
| See above.
template<class INTEGER>
const TYPE & | operator[] (INTEGER index) const
| See above.
void | set (size_t index, const TYPE &value)
| Modifies one existing value held by this parameter.
void | insert (size_t index, const TYPE &value)
| Inserts a value to this parameter.
void | insert (size_t index, size_t count, const TYPE &value)
| Inserts one value, multiple times, to this list parameter.
void | insert (size_t index, const TYPE *values, size_t count)
| Inserts multiple values to this list parameter.
void | erase (size_t index)
| Removes one element from this list parameter.
void | erase (const TYPE &value)
| Removes one element from this list parameter.
void | erase (size_t start, size_t end)
| Removes a contiguous series of elements from this list parameter.
void | clear ()
| Removes all the element of the list parameter.
size_t | find (const TYPE &value) const
| Retrieves the index of an existing value in this parameter.
bool | contains (const TYPE &value) const
| Retrieves whether the list parameter contains a specific value.
void | push_back (const TYPE &value)
| Appends one value to this parameter.
void | push_front (const TYPE &value)
| Adds one value at the beginning of this list parameter.
void | pop_back ()
| Removes the value at the end of the list parameter.
void | pop_front ()
| Removes the value at the end of the list parameter.
TYPE & | front ()
| Retrieves the first element from this list parameter.
const TYPE & | front () const
| See above.
TYPE & | back ()
| Retrieves the last element from this list parameter.
const TYPE & | back () const
| See above.
TYPE ** | GetDataPtr ()
| [INTERNAL] Retrieves a pointer to the source data.
const TYPE ** | GetDataPtr () const
| See above.
fm::vector< TYPE, true > & | GetDataList ()
| [INTERNAL] Retrieves a reference to the inner value list.
const fm::vector< TYPE, true > & | GetDataList () const
| See above.
size_t | capacity () const
| Retrieves the number of pre-allocated values reserved by this value list.
## Protected Member Functions
virtual FCDAnimated * | CreateAnimated (size_t index)
| Created the correct FCDAnimated helper object, done by request from the parent class.

## Detailed Description

### template<class TYPE, int QUALIFIERS>
class FCDParameterListAnimatableT< TYPE, QUALIFIERS >

A typed animatable FCollada value parameter.

## Constructor & Destructor Documentation

template<class TYPE, int QUALIFIERS>
FCDParameterListAnimatableT< TYPE, QUALIFIERS >::FCDParameterListAnimatableT | ( | FUParameterizable * | parent | ) |

  | Constructor. Parameters:
  | parent | The FCollada object that owns this parameter.

## Member Function Documentation

template<class TYPE, int QUALIFIERS>
const TYPE& FCDParameterListAnimatableT< TYPE, QUALIFIERS >::at | ( | size_t | index | ) | const`[inline]`

  | Retrieves one value held by this parameter. Important: it is intentional that you cannot modify a list value using these function. Instead, use the set function. Parameters:
  | index | The index of the value held by this parameter.
Returns: The number of values in this parameter.

template<class TYPE, int QUALIFIERS>
TYPE& FCDParameterListAnimatableT< TYPE, QUALIFIERS >::back | ( |  | ) | `[inline]`

  | Retrieves the last element from this list parameter. Parameters:
  | The | last element in the list parameter.

template<class TYPE, int QUALIFIERS>
size_t FCDParameterListAnimatableT< TYPE, QUALIFIERS >::capacity | ( |  | ) | const`[inline]`

| Retrieves the number of pre-allocated values reserved by this value list. Returns: The number of pre-allocated values reserved.

template<class TYPE, int QUALIFIERS>
bool FCDParameterListAnimatableT< TYPE, QUALIFIERS >::contains | ( | const TYPE & | value | ) | const`[inline]`

  | Retrieves whether the list parameter contains a specific value. Parameters:
  | value | A value.
Returns: Whether the given value is contained within the list parameter.

template<class TYPE, int QUALIFIERS>
virtual FCDAnimated* FCDParameterListAnimatableT< TYPE, QUALIFIERS >::CreateAnimated | ( | size_t | index | ) | `[protected, virtual]`

| Created the correct FCDAnimated helper object, done by request from the parent class. Returns: A newly-created FCDAnimated helper object. Reimplemented from FCDParameterListAnimatable.

template<class TYPE, int QUALIFIERS>
bool FCDParameterListAnimatableT< TYPE, QUALIFIERS >::empty | ( |  | ) | const`[inline]`

| Retrieves whether this list parameter contains values. Returns: Whether the list parameter is empty.

template<class TYPE, int QUALIFIERS>
void FCDParameterListAnimatableT< TYPE, QUALIFIERS >::erase | ( | size_t | start,
|  | size_t | end
| ) |

  | Removes a contiguous series of elements from this list parameter. Parameters:
  | start | The index of the first element to remove.
  | end | The index past the last element to remove.

template<class TYPE, int QUALIFIERS>
void FCDParameterListAnimatableT< TYPE, QUALIFIERS >::erase | ( | const TYPE & | value | ) |

  | Removes one element from this list parameter. Parameters:
  | value | The value to remove.

template<class TYPE, int QUALIFIERS>
void FCDParameterListAnimatableT< TYPE, QUALIFIERS >::erase | ( | size_t | index | ) |

  | Removes one element from this list parameter. Parameters:
  | index | The index of the element to remove.

template<class TYPE, int QUALIFIERS>
size_t FCDParameterListAnimatableT< TYPE, QUALIFIERS >::find | ( | const TYPE & | value | ) | const`[inline]`

  | Retrieves the index of an existing value in this parameter. Parameters:
  | value | The value to look for.
Returns: The index of the given value within the parameter. The size of the list is returned if the value is not found.

template<class TYPE, int QUALIFIERS>
TYPE& FCDParameterListAnimatableT< TYPE, QUALIFIERS >::front | ( |  | ) | `[inline]`

  | Retrieves the first element from this list parameter. Parameters:
  | The | first element in the list parameter.

template<class TYPE, int QUALIFIERS>
fm::vector<TYPE, true>& FCDParameterListAnimatableT< TYPE, QUALIFIERS >::GetDataList | ( |  | ) | `[inline]`

| [INTERNAL] Retrieves a reference to the inner value list. Not recommended. Returns: A reference to the value list.

template<class TYPE, int QUALIFIERS>
TYPE** FCDParameterListAnimatableT< TYPE, QUALIFIERS >::GetDataPtr | ( |  | ) | `[inline]`

| [INTERNAL] Retrieves a pointer to the source data. Not recommended. Returns: A pointer to the source data.

template<class TYPE, int QUALIFIERS>
void FCDParameterListAnimatableT< TYPE, QUALIFIERS >::insert | ( | size_t | index,
|  | const TYPE * | values,
|  | size_t | count
| ) |

  | Inserts multiple values to this list parameter. Parameters:
  | index | Where to insert the values.
  | values | A static list of values.
  | count | The number of values to insert.

template<class TYPE, int QUALIFIERS>
void FCDParameterListAnimatableT< TYPE, QUALIFIERS >::insert | ( | size_t | index,
|  | size_t | count,
|  | const TYPE & | value
| ) |

  | Inserts one value, multiple times, to this list parameter. Parameters:
  | index | Where to insert the value.
  | count | The number of times to insert this value.
  | value | The value to insert to this parameter.

template<class TYPE, int QUALIFIERS>
void FCDParameterListAnimatableT< TYPE, QUALIFIERS >::insert | ( | size_t | index,
|  | const TYPE & | value
| ) |

  | Inserts a value to this parameter. Parameters:
  | index | Where to insert the value.
  | value | The values to insert to this parameter.

template<class TYPE, int QUALIFIERS>
void FCDParameterListAnimatableT< TYPE, QUALIFIERS >::push_back | ( | const TYPE & | value | ) |

  | Appends one value to this parameter. Parameters:
  | value | The value to add to this parameter.

template<class TYPE, int QUALIFIERS>
void FCDParameterListAnimatableT< TYPE, QUALIFIERS >::push_front | ( | const TYPE & | value | ) |

  | Adds one value at the beginning of this list parameter. Parameters:
  | value | The value to add to this parameter.

template<class TYPE, int QUALIFIERS>
void FCDParameterListAnimatableT< TYPE, QUALIFIERS >::resize | ( | size_t | count,
|  | const TYPE & | value
| ) |

  | Sets the number of values contained in the list parameter. Parameters:
  | count | The new number of values contained in the parameter.
  | value | The default value to insert in the new slots of the list parameter.

template<class TYPE, int QUALIFIERS>
void FCDParameterListAnimatableT< TYPE, QUALIFIERS >::resize | ( | size_t | count | ) |

  | Sets the number of values contained in the list parameter. Parameters:
  | count | The new number of values contained in the parameter.

template<class TYPE, int QUALIFIERS>
void FCDParameterListAnimatableT< TYPE, QUALIFIERS >::set | ( | size_t | index,
|  | const TYPE & | value
| ) |

  | Modifies one existing value held by this parameter. Parameters:
  | index | The index of the value to change.
  | value | The new value.

template<class TYPE, int QUALIFIERS>
size_t FCDParameterListAnimatableT< TYPE, QUALIFIERS >::size | ( |  | ) | const`[inline]`

| Retrieves the number of values in this parameter list. See above. Returns: The number of values.

The documentation for this class was generated from the following files:

- FCDocument/FCDParameterAnimatable.h
- FCDocument/FCDParameterAnimatable.hpp